"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chalk = require("chalk"), stringKit = require("string-kit");
class Debug {
    static trace(name, ...args) {
        this.call("trace", name, ...args);
    }
    static error(name, ...args) {
        this.call("error", name, ...args);
    }
    static call(method, name, ...args) {
        console.group(name, chalk.white.bgCyan.bold(" " + name + " "));
        args.forEach((value) => {
            console.group(chalk.white.bgBlue.bold(" " + typeof value + " "));
            console.log(stringKit.inspect({
                style: chalk.enabled ? "color" : "none",
                proto: false,
                depth: 16,
                funcDetails: false,
            }, value));
            console.groupEnd();
        });
        console.groupEnd();
    }
}
exports.Debug = Debug;
//# sourceMappingURL=debug.js.map