"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const bunyan_1 = __importDefault(require("bunyan"));
class LogLevel {
    constructor(levels, stream) {
        let self = this;
        this.levels = {};
        levels.forEach(function (lvl) {
            self.levels[bunyan_1.default.resolveLevel(lvl)] = true;
        });
        this.stream = stream;
    }
    write(rec) {
        /* istanbul ignore next */
        if (this.levels[rec.level] !== undefined) {
            let str = JSON.stringify(rec, bunyan_1.default.safeCycles()) + "\n";
            this.stream.write(str);
        }
    }
}
module.exports = bunyan_1.default.createLogger({
    name: require("../package.json").name,
    streams: [
        {
            level: "trace",
            type: "raw",
            stream: new LogLevel(["trace", "debug", "info"], process.stdout),
        }, {
            level: "error",
            type: "raw",
            stream: new LogLevel(["warn", "error"], process.stderr),
        },
    ],
});
//# sourceMappingURL=logger.js.map