"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const url = __importStar(require("url"));
const superagent = __importStar(require("superagent"));
const converter_1 = require("./converter");
class Webhook {
    static send(req) {
        return new Promise((resolve, reject) => {
            const parsed = url.parse(req.url, true);
            const webhookUrl = "https://chat.googleapis.com/v1/spaces/" + req.params["space"] + "/messages" + parsed.search;
            superagent.post(webhookUrl)
                .set("Content-Type", "application/json; charset=UTF-8")
                .send(converter_1.Converter.convert(req.body))
                .then((response) => {
                resolve({
                    status: response.status,
                    headers: response.header,
                    body: response.body
                });
            })
                .catch((err) => {
                reject({
                    status: err.status,
                    headers: err.header,
                    body: err.body,
                    error: err.response && err.response.text ? JSON.parse(err.response.text) : "Request failed",
                });
            });
        });
    }
    static express(req, res) {
        Webhook.send(req)
            .then(value => res
            .status(value.status)
            .json(value))
            .catch(reason => res
            .status(reason.status)
            .json(reason));
    }
    ;
}
exports.Webhook = Webhook;
//# sourceMappingURL=send.js.map